 #!/usr/bin/env python

"""
  Author:  Yeison Cardona --<yeison.eng@gmail.com>
  Purpose:
  Created: 17/10/15
"""

from collections import OrderedDict
import re



########################################################################
class Parser:
    """"""

    #----------------------------------------------------------------------
    def __init__(self, docstring, request=None):
        """Constructor"""

        regex_section = r"([\w]+\s[-]+)"
        regex_param = r"([\w]+):([\w, ]*)\s"

        docstring = self.remove_spaces(docstring).format(**request.META)

        sections = re.findall(regex_section, docstring, re.MULTILINE | re.DOTALL)

        if len(sections) == 3:

            self.docstring = OrderedDict()

            for i in range(2):
                start = docstring.find(sections[i])
                end = docstring.find(sections[i+1])
                self.docstring[sections[i].replace("\n", "").replace("-", "")] = self.fix_args(re.findall(regex_param, docstring[start+len(sections[i]):end], re.MULTILINE | re.DOTALL), docstring)

            start = docstring.find(sections[2])
            self.examples = self.get_examples(docstring[start+len(sections[2]):])

        else:
            self.docstring = None
            self.examples = None





    #----------------------------------------------------------------------
    def fix_args(self, args, docstring):
        """"""
        args_ = []
        for i in range(len(args)):
            arg_ = OrderedDict()
            arg_["name"] = args[i][0]
            arg_["args"] = self.remove_spaces(args[i][1].replace(",", " ")).replace(" ", ", ")


            start = docstring.find("{0}:{1}".format(*args[i]))
            try:
                end = docstring.find("{0}:{1}".format(*args[i+1]))
            except IndexError:
                end = docstring.find("---")
                end = docstring.rfind("\n", 0, end-1)

            arg_["description"] = self.remove_spaces(docstring[start+len("{0}:{1}".format(*args[i])):end])

            args_.append(arg_)

        return args_


    #----------------------------------------------------------------------
    def get_examples(self, docstring):
        """"""

        docstring = self.remove_spaces(docstring).split("\n")

        examples = []

        for i in range(0, int(len(docstring)/2)+1, 2):
            ex = OrderedDict()
            ex["description"] = docstring[i]
            ex["snippet"] = docstring[i+1]

            examples.append(ex)

        return examples


    #----------------------------------------------------------------------
    def remove_spaces(self, str):
        """"""

        spaces = [" "*i for i in range(2, 15)]
        spaces.reverse()
        for space in spaces:
            str = str.replace(space, " ")

        br = ["\n"*i for i in range(2, 15)]
        br.reverse()
        for b in br:
            str = str.replace(b, "\n")

        if str.startswith(" ") or str.startswith("\n"):
            str = str[1:]

        if str.endswith(" ") or  str.endswith("\n"):
            str = str[:-1]

        return str




    #----------------------------------------------------------------------
    def get_sections(self):
        """"""



    #----------------------------------------------------------------------
    def get_section(self):
        """"""


